User account creation filtered due to spam.

Bug 19424 - [4.0 Regression] Error: suffix or operands invalid for `movlps'
Summary: [4.0 Regression] Error: suffix or operands invalid for `movlps'
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 4.0.0
: P2 normal
Target Milestone: 4.0.0
Assignee: Not yet assigned to anyone
URL:
Keywords: ssemmx, wrong-code
Depends on:
Blocks:
 
Reported: 2005-01-13 13:29 UTC by Uroš Bizjak
Modified: 2005-01-18 06:33 UTC (History)
2 users (show)

See Also:
Host: i686-pc-linux-gnu
Target: i686-pc-linux-gnu
Build: i686-pc-linux-gnu
Known to work:
Known to fail:
Last reconfirmed: 2005-01-14 14:13:55


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Uroš Bizjak 2005-01-13 13:29:37 UTC
gcc -O0 -msse i386-sse-1.c
/tmp/cc9PodHq.s: Assembler messages:
/tmp/cc9PodHq.s:4557: Error: suffix or operands invalid for `movlps'
/tmp/cc9PodHq.s:4558: Error: suffix or operands invalid for `movlps'
/tmp/cc9PodHq.s:4579: Error: suffix or operands invalid for `movlps'
/tmp/cc9PodHq.s:4580: Error: suffix or operands invalid for `movlps'

These movlps errors refer to:
_mm_set_ps:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movss	20(%ebp), %xmm1
	movss	16(%ebp), %xmm0
	unpcklps	%xmm0, %xmm1
	movss	12(%ebp), %xmm2
	movss	8(%ebp), %xmm0
	movaps	%xmm2, %xmm3
	unpcklps	%xmm0, %xmm3
(*)	movlps	%xmm3, %xmm0
(*)	movlps	%xmm1, %xmm2
	movlhps	%xmm0, %xmm2
	movaps	%xmm2, %xmm0
	movaps	%xmm0, -24(%ebp)
	movaps	-24(%ebp), %xmm0
	leave
	ret

and

_mm_setr_ps:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movss	8(%ebp), %xmm1
	movss	12(%ebp), %xmm0
	unpcklps	%xmm0, %xmm1
	movss	16(%ebp), %xmm2
	movss	20(%ebp), %xmm0
	movaps	%xmm2, %xmm3
	unpcklps	%xmm0, %xmm3
(*)	movlps	%xmm3, %xmm0
(*)	movlps	%xmm1, %xmm2
	movlhps	%xmm0, %xmm2
	movaps	%xmm2, %xmm0
	movaps	%xmm0, -24(%ebp)
	movaps	-24(%ebp), %xmm0
	leave
	ret

Note that movlps cannot handle two registers as its operands.
Comment 1 uros 2005-01-14 14:13:55 UTC
Register constraints are wrong for movv2sf* patterns. "movlps" can't handle the
combination of x/x registers.

Uros.
Comment 2 Steven Bosscher 2005-01-15 12:37:20 UTC
SSE bug -> rth
Comment 3 CVS Commits 2005-01-18 06:18:14 UTC
Subject: Bug 19424

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	uros@gcc.gnu.org	2005-01-18 06:17:56

Modified files:
	gcc            : ChangeLog 
	gcc/config/i386: mmx.md 

Log message:
	PR target/19424
	* config/i386/mmx.md (*movv2sf_internal_rex64, *movv2sf_internal):
	Add movaps alternative for xmm reg->reg move.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&r1=2.7165&r2=2.7166
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/config/i386/mmx.md.diff?cvsroot=gcc&r1=1.3&r2=1.4

Comment 4 Uroš Bizjak 2005-01-18 06:33:57 UTC
Fixed.